/* Zaklady programovani v C++
   Okomentovane priklady ze cviceni ... jednorozmerne staticke pole II
*/

#include<iostream>
#include<string>

using namespace std;

struct Datum
{
	unsigned short den;
	unsigned short mesic;
	int rok;
};

struct Predmet
{
	string nazev;
	Datum terminy_zkousek[5];
};

enum Pozice { vratny, programator, ucetni, manazer };
const string nazev_pozice[] = { "vratny", "programator", "ucetni", "manazer" };

struct Zamestnanec
{
	string jmeno;
	string prijmeni;
	Datum nastup;
	int plat;
	Pozice pozice;
};

void nacti_zamestnance(Zamestnanec pobocka[], int n)
{
	for (int i = 0; i < n; i++)
	{
		cout << "Zadej zamestnance c. " << i << endl;
		cout << "Jmeno: ";
		cin >> pobocka[i].jmeno;
		cout << "Prijmeni: ";
		cin >> pobocka[i].prijmeni;
		cout << "Pozice: (vratny ...0, programator ... 1, ucetni ... 2, manazer ... 3)";
		int poz;
		cin >> poz;
		pobocka[i].pozice = (Pozice)poz;;
		cout << "Plat: ";
		cin >> pobocka[i].plat;
		cout << "Nastup \n den: ";
		cin >> pobocka[i].nastup.den;
		cout << "Nastup \n mesic: ";
		cin >> pobocka[i].nastup.mesic;
		cout << "Nastup \n rok: ";
		cin >> pobocka[i].nastup.rok;

		if (cin.fail())
		{
			cout << "Chybny vstup. Zadej zamestnance znovu." << endl;
			cin.clear();
			cin.ignore(256, '\n');
			i--;
		}
	}
}

void vypis_zamestnancu(Zamestnanec pobocka[], int n)
{
	for (int i = 0; i < n; i++)
	{
		cout << "Jmeno: " << pobocka[i].jmeno << endl;
		cout << "Prijmeni: " << pobocka[i].prijmeni << endl;
		cout << "Pozice: " << nazev_pozice[pobocka[i].pozice] << endl;
		cout << "Plat: " << pobocka[i].plat << endl;
		cout << "Nastup: " << pobocka[i].nastup.den << "."
			<< pobocka[i].nastup.mesic << "."
			<< pobocka[i].nastup.rok << endl << endl;
	}
}

int main()
{
	// Datum datum; // bez inicializace
	Datum narozen = { 1,1,1998 };
	//Datum dnes = {29,10,}; // rok bude 0
	Datum dnes = { 29,10,2018 };
	Datum terminy_zkousek[10] = { {1,2,2019},{8,2,2019} };

	Datum datum;
	datum.den = 28;
	datum.mesic = 10;
	datum.rok = 1918;

	int uplynulo_let = dnes.rok - narozen.rok;
	Datum vcera = dnes;
	vcera.den--;


	Predmet matalyza = { "Matematick analza", {{1,2,2019},{10,2,2019},} };
	Predmet lingebra = matalyza;
	lingebra.nazev = "Linearni algebra";
	/* netreba:
	for (int i = 0; i < 5; i ++)
		 lingebra.terminy_zkousek[i] = matalyza.terminy_zkousek[i];
	*/

	Zamestnanec pepa = { "Josef", "Novak", {2, 1, 2018}, 25000, };
	Zamestnanec jana = { "Jana", "Svobodova" };

	// vytvareni pole struktur
	Zamestnanec pobocka_praha[4];
	pobocka_praha[0] = pepa;   // pouziju z predchoziho


	pobocka_praha[1].jmeno = "Tomas";
	pobocka_praha[1].prijmeni = "Novotny";
	pobocka_praha[1].plat = 80000;
	pobocka_praha[1].pozice = programator;
	pobocka_praha[1].nastup = pepa.nastup;

	pobocka_praha[2] = pepa;
	pobocka_praha[2].jmeno = "Filip";
	pobocka_praha[2].pozice = ucetni;
	pobocka_praha[2].nastup = vcera;

	jana.pozice = programator;
	pobocka_praha[3] = jana;

	vypis_zamestnancu(pobocka_praha, 4);
	nacti_zamestnance(pobocka_praha, 4);
	vypis_zamestnancu(pobocka_praha, 4);

	return 0;
}
