/* Zaklady programovani v C++
   Okomentovane priklady ze cviceni ... prikaz switch
*/

#include <iostream>
using namespace std;

const double pi = 3.1415926;

// informativni deklarace funkci:
double obsah_ctverce(double strana);
double obsah_kruhu(double polomer);
double objem_valce(double polomer, double vyska);
double objem_koule(double polomer);


int main()
{
	double r, v, x;
	char volba;
	cout << "Kalkulacka pro vypocet objemu a obsahu" << endl;
	do {
		cout << "Pro vypocet obsahu ctverce stiskni a" << endl;
		cout << "Pro vypocet obsahu kruhu stiskni b" << endl;
	    cout << "Pro vypocet objemu valce stiskni c" << endl;
		cout << "Pro vypocet objemu koule stiskni d" << endl;
		cout << "Pokud chces ukoncit vypocet, stiskni k" << endl;
		if (!(cin >> volba))
		{
			volba = 'k';
		}
		switch (volba)
		{
		    case 'A':
			case 'a':
				cout << "Zadej delku strany ctverce: " << endl;
				cin >> r;
				x = obsah_ctverce(r);
				cout << "Obsah ctverce je " << x << "." << endl;
				break;
		    case 'B':
            case 'b':
				cout << "Zadej polomer kruhu: " << endl;
				cin >> r;
				x = obsah_kruhu(r);
				cout << "Obsah kruhu je " << x << "." << endl;
				break;
		    case 'C':
			case 'c':
				cout << "Zadej polomer valce: " << endl;
				cin >> r;
				cout << "Zadej vysku valce: " << endl;
				cin >> v;
				x = objem_valce(r,v);
				cout << "Objem valce je " << x << "." << endl;
				break;
			case 'D':
			case 'd':
				cout << "Zadej polomer koule: " << endl;
				cin >> r;
				x = objem_koule(r);
				cout << "Objem koule je " << x << "." << endl;
				break;
			default:
				cout << "Konec" << endl;
				volba = 'k';
		}
		cout << endl;
	}
	while (volba!= 'k');

	return 0;
}

/* Funkce spocita obsah ctverce
   strana ... delka strany ctverce
*/
double obsah_ctverce(double strana)
{
	return strana * strana;
}

/* Funkce spocita obsah kruhu na zaklade jeho polomeru
*/
double obsah_kruhu(double polomer)
{
	return pi * polomer * polomer;
}

/* Funkce spocita objem valce na zaklade jeho polomeru a vysky
*/
double objem_valce(double polomer, double vyska)
{
	return vyska * obsah_kruhu(polomer);
}

/* Funkce spocita objem koule na zaklade jejiho polomeru
*/
double objem_koule(double polomer)
{
	return 4.0 / 3 * polomer * obsah_kruhu(polomer);
}
